Skip to main content
`Ctrl`+`K`

# KSPSetInitialGuessNonzero

Tells the iterative solver that the initial guess is nonzero; otherwise `KSP` assumes the initial guess is to be zero (and thus zeros it out before solving).

## Synopsis

    #include "petscksp.h"
    #include "petscmat.h"
    PetscErrorCode KSPSetInitialGuessNonzero(KSP ksp, PetscBool flg)

Logically Collective

## Input Parameters

- ksp - iterative solver obtained from `KSPCreate()`

- flg - `PETSC_TRUE` indicates the guess is non-zero, `PETSC_FALSE` indicates the guess is zero

## Options Database Key

- -ksp_initial_guess_nonzero <true,false> - use nonzero initial guess

## Note

If this is not called the X vector is zeroed in the call to `KSPSolve()`.

## See Also

KSP: Linear System Solvers, `KSPGetInitialGuessNonzero()`, `KSPGuessSetType()`, `KSPGuessType`, `KSP`

## Level

beginner

## Location

src/ksp/ksp/interface/itfunc.c

## Examples

src/ksp/pc/tutorials/ex1.c
src/ksp/ksp/tutorials/ex51.c
src/ksp/ksp/tutorials/ex9.c
src/ksp/ksp/tutorials/ex84.c
src/ksp/ksp/tutorials/ex27.c
src/ksp/ksp/tutorials/ex72.c
src/ksp/ksp/tutorials/ex6f.F90
src/ksp/ksp/tutorials/ex56.c
src/ksp/ksp/tutorials/ex3.c
src/ksp/ksp/tutorials/ex71.c

Index of all KSP routines
Table of Contents for all manual pages
Index of all manual pages